
import java.util.*;

public class ATM extends Observable {

	/**
	 *  The server which will handle transactions for this
	 *  ATM
	 */
	private ATMServer atmServer_;
	public ATMServer atmServer() { return atmServer_; }
	public void atmServer( ATMServer anATMServer ) { atmServer_ = anATMServer; }

    ATM() {
        this.initialize();
    }

    private void initialize() {
        this.atmServer(new ATMServer());
    }

    public void publicize(String aString) {
        this.setChanged();
        this.notifyObservers(aString);
    }

    public void enterDeposit(String userID, String PIN, double amount) {
        Account anAccount = this.atmServer().requestService(userID, PIN);
        if (anAccount != null) {

            this.publicize("");
            this.publicize("Deposit " + amount);
            this.publicize("Current Balance before deposit = "
                                                  + anAccount.balance());

            Transaction aTransaction = new Deposit(anAccount, amount);
            this.atmServer().submitTransaction(aTransaction);

            this.publicize("New Balance = " + anAccount.balance());
        }

        else {
            this.publicize("ACCOUNT_INVALID");
        }
    }

    public void enterWithdrawal(String userID, String PIN, double amount) {
        Account anAccount = this.atmServer().requestService(userID, PIN);
        if (anAccount != null) {

            this.publicize("");
            this.publicize("Withdraw " + amount);
            this.publicize("Current Balance before withdrawal = "
                                                     + anAccount.balance());

            Transaction aTransaction = new Withdrawal(anAccount, amount);
            this.atmServer().submitTransaction(aTransaction);

            this.publicize("New Balance = " + anAccount.balance());
        }

        else {
            this.publicize("ACCOUNT_INVALID");
        }
    }

}